:   HINT
H='
=========
noter file(s)
=========
noter tries to identify mismatched # (textnote) and
.NS/.NE sequences
=========
'
case    $1 in
    -h|help|hint)   clear;echo "$H";exit 0;;
    *)  ;;
esac
X='
BEGIN   {
		filename = ""
		lastqs =lastns = innote = tn = fn = 0;
        }
		{
		if(FILENAME != filename)	{
			NR = 0;
			filename = FILENAME
			}
		}
/#$/    {
        tn += 1;
        ln = NR + 1;
        lnx = $0;
        }
/^\.QS/ {
        if(lastqs)
            printf("%s unexpected 'QS' = %d\n",FILENAME,NR);
        lastqs = NR
        }
/^\.QE/ {
        if(!lastqs)
            printf("%s unexpected 'QE' = %d\n",FILENAME,NR);
        lastqs = 0
        }
/^\.NS/ {
		ns += 1
        if(innote >= 1)   {
            printf("%s nested note 'NS' = %d\n",FILENAME,lastns);
        exit
            }
        if(NR != ln)    {
        if(ln <= 0)
        printf("%s no text note before NS at %d\n",FILENAME,NR);
        else
                printf("%s no note following '#' at %d\n",FILENAME,ln);
        printf("%d %d %s\n",NR,ln,lnx);
        exit
            }
        fn = fn + 1;
        if(fn != tn)        {
            printf("%s note mismatch '#' = %d 'NS' = %d\n",FILENAME, ln,NR);
            #printf("%s\n",tx);
            #printf("%d %d\n",fn,ln);
            fn = ln;
            }
        innote += 1;
    lastns = NR;
        lx = NR + 1;
    ln = 0;
        }
/^\.NE/ {
	ne += 1
    innote -= 1;
    if(innote < 0)  {
        printf("%s unexpected 'NE' at %d\n",FILENAME,NR);
        exit
        }
        }
    {
    if(lastqs && NR > (lastqs+20))
        {
        printf("%s very long 'QS' at %d\n",FILENAME,lastqs);
        lastqs = 0;
        }
    }
END{
	if(ns != ne)	printf("NS (%d)count != NE (%d) count\n",ns,ne);
	}
'
if test -t 1
then
awk -e "$X" $* | more
else
awk -e "$X" $*
fi
