#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include    "kawkdefs.h"
#include	"ksysprot.h"
#include	"kawkfunc.h"
/*EXTERN*/
/*DEFINE*/
lexset(nu)
NOSIGN	nu;
{
	return(lexlevel = nu);
}
brackset(nu)
NOSIGN	nu;
{
	return(bracket = nu);
}
char	*
lncomp(is)			/* logical negation */
char	*is;
{
	is = muldivcomp(is);
	addcode( (FUNCP) xdtol,"xdtol");
	addcode( (FUNCP) xlneg,"xlneg");
	return(skipbs(is));
}
char	*
onescomp(is)		/* one's complement */
char	*is;
{
	is = muldivcomp(is);
	addcode( (FUNCP) xonec,"xonec");
	return(skipbs(is));
}
char	*
umcomp(is)			/* unitary minus */
char	*is;
{
	is = muldivcomp(is);
	addcode( (FUNCP) xum,"xum");
	return(skipbs(is));
}
char	*
intcomp(is)
char	*is;
{
	is = exprcomp(is);
	addcode( (FUNCP) xdtoi,"xdtoi");
	return(skipbs(is));
}
char	*
floatcomp(is)
char	*is;
{
	is = exprcomp(is);
	addcode( (FUNCP) xitod,"xitod");
	return(skipbs(is));
}
char    *
parencomp(is)		/* parenthetized expression */
char	*is;
{
	REG		char	*isx = is;
	isx = exprcomp(is);
	if(*isx != ')')	{
		errptr(is,"<missing right paren>\n");
		return(NULL);
		}
	else	{
		return(skipbs(++isx));
		}
}
hasnstr(os,is,nc)
char	*os;
char	*is;
NOSIGN	nc;
{
	return(!strncmp(os,is,nc));
}
is_con(is)
char	*is;
{
	return(isdigit(*is) || *is == '.');
}
is_sym(is)
char	*is;
{
	return(isalpha(*is) || *is == '_');
}
