#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
#include	"keyproto.h"
/**/
#ifdef	CYCLE
short	cycle;
#endif	/*CYCLE*/
/*EXTERN*/
extern	int		gtmark();
extern	void	domark();
extern	void	dolerr();
extern	void	locked();
/**/
void
locked(is)
char	*is;
{
	auto	char	*fn;
	fn = xpandsh(is,NULL);
	if(isnull(fn))	orphans('s',"locked",NULL);
	else			orphans('l',"locked",fn);
	query(stderr);
}
void
dohi()
{
	khint("ked","");
}
void
dosh(is)
char	*is;
{
	auto	char	ws[FNMSIZ];
/**/
	if(is[0] == '!')	is += 1;
	if(isnull(is))		strcpy(ws,"sh");
	else				strcpy(ws,is);
/**/
	xdoshell(ws,efnget(),keysget());
}
void
doqu()
{
	query(stdout);
}
void
dotft()
{
	tellfile(TERSE);
}
void
dotfv()
{
	tellfile(VERBOSE);
}
void
dobuf()
{
	showcbt(stdout);
}
void
domm()
{
	keysmem(stdout);
}
void
doed(is)
char	*is;
{
	doedit(is);
	tellfile(TERSE);
}
void
docl()
{
	scr_cl(stdout);
}
void
illegal(is)
char	*is;
{
	auto	char	*list = "set, syn, ?, !, F, f, M, e, h, k, X, q";
	printff("\007<legal commands without buffer>\n");
	scr_so(stdout);
	puts(list);
	scr_se(stdout);
	terror(FUBAR);
}
void
docd(is)
char	*is;
{
	auto	int		check = cdx.del;
/**/
	strcnd(is);
/**/
	if(is[0] == '!')	{
		check = ZERO;
		is = strcnd(is+1);
		}
/**/
	if(check)	{
			errmsg("<unwritten changes> use cd! %s\n",is);
			terror(FUBAR);
			}
/**/
	if(kchdir(is) < 0)	terror(FUBAR);
}
rdcmd(fp,pr)    /* read commands from stdin */
FILE    *fp;
int     pr;
{
	auto	char	ls[FNMSIZ];
/**/
	while(rdcmp(ls,ls+FNMSIZ-1,fp,pr,kenv.pname))	{
/**/
/*	TEMPORARY KLUDGE */
/**/
		if(strncmp(ls,"syn",3) == ZERO)		{
			synsyn(strcnd(ls+3));
			continue;
			}
/**/
		if(cansyn)	get_syn(ls);
/**/
		if(ls[0] == '.' && ls[1] == '.')	{
			strcpy(ls,lcmd);
			rdstr(ls);
			}
		else								{
			strcpy(lcmd,ls);
			rdstr(ls);
			}
		}
/**/
	return(ZERO);
}
rdstr(is)	/* read through cmd@cmd@cmd patterns */
char	*is;
{
	auto	char	ws[FNMSIZ];
	auto	char	*isx = is;
	if(isnull(is))	strcpy(is,"+1Z");
	while((int) (isx = xgnc(ws,ws+FNMSIZ-1,isx,'@')))	{
		if(isnull(is))	strcpy(ws,"+1Z");
		parsex(ws);
		}
	return(ZERO);
}
/**/
typedef	struct	DOCM	{
	char	*cn;
	int		co;
	FUNCP	fn;
	}	DOCM;
/**/
DOCM 	docm[] = {
		"!",0, (FUNCP) dosh,
		":",0, (FUNCP) NULL,
		"?",1, (FUNCP) dohi,
		"B",0, (FUNCP) dobuf,
		"D",0, (FUNCP) dodi,
		"E",0, (FUNCP) dolerr,
		"F",1, (FUNCP) dotfv,
		"H",0, (FUNCP) sethash,
		"K",1, (FUNCP) whatkey,
		"L",1, (FUNCP) docl,
		"M",1, (FUNCP) domm,
		"Q",1, (FUNCP) doqu,
		"T",0, (FUNCP) twrset,
		"X",1, (FUNCP) kedrec,
		"cd",2, (FUNCP) docd,
		"e",1, (FUNCP) doed,
		"f",1, (FUNCP) dotft,
		/* "k",1, (FUNCP) whatkey, */
		"q",1, (FUNCP) doquit,
		"set",3,(FUNCP) setset,
		"sh",0, (FUNCP) dosh,
		"so",2, (FUNCP) doso,
		"syn",3,(FUNCP) synsyn,
		"td",2,(FUNCP) set_tmp_dir,
		"O",1, (FUNCP) locked,
		"u",1, (FUNCP) undop,
		"x",1, (FUNCP) kedexit,
		NULL,0, (FUNCP) NULL,
	}	;
void
dolerr(is)
char	*is;
{
	getlerr(stderr);
}
void
dodi(is)
char	*is;
{
	while(isalpha(*is))	++is;
	kenv.diagno = atoi(is);
}
parsex(is)		/* id command, execute function */
char	*is;
{
	auto	DOCM	*docx = docm;
	auto	FUNCP	f;
/**/
	cdx.con = YES;
	cdx.glb = NO;
/**/
	while(docx->cn)	{
		if(strcmd(is,docx->cn,docx->co) == 0)	{
			f = docx->fn;
			if(f)	(*f)(strcnd(is+docx->co));
			return;
			}
		docx += 1;
		}
/**/
	if(!bfp)	illegal(NULL);
	else 		{
		pcmd0(is);
		}
/**/
	return;
}
strcmd(os,is,nc)
char	*os;
char	*is;
int		nc;
{
	if(nc == ZERO)	{
		if(strncmp(os,is,strlen(is)) == ZERO)	return(ZERO);
		else									return(1);
		}
	if(strncmp(os,is,nc) == ZERO && (os[nc] == ZERO ||
		os[nc] == '?' || os[nc] == ' ' || os[nc] == '!'))	
			return(ZERO);
	return(1);
}
/**/
/*EXTERN*/
/**/
/*STATIC*/
/**/
static	FILE	*pfp = stdout;
/**/
char	*
rdcmp(os,us,fp,pr,ps)		/* write prompt, get command */
char	*os;
char	*us;
FILE	*fp;
int		pr;		/* prompt? */
char	*ps;	/* prompt string */
{
	auto	int	loop = 1;
/**/
	while(loop)	{
/**/
	if(pr)  {
		scr_so(pfp);
		if(kenv.leisur & DA)	{
			scr_bs(pfp);
			scr_ce(pfp);
			}
#ifdef	CYCLE
		fprintf(pfp,"(%d:%d)=>",ub.ulatch,++cycle);
#else	/*CYCLE*/
		fprintf(pfp,"(%s)=>",ps);
#endif	/*CYCLE*/
		scr_se(pfp);
		fflush(pfp);
	}
/**/
	if(!fgetlf(os,us,fp))			{
		if(pr)	{
				clearerr(fp);
				fubar(FUBAR);
				}
		else	return(ZERO);
		}
/**/
	fprintf(pfp,"\r");
	if(hascntrl(os))    			continue;
	else					loop = ZERO;
/**/
	if(kenv.leisur & DA)			{
		scr_ce(pfp);
		fflush(pfp);
		}
	}
/**/
	return(os);
}
xdoshell(is,fa,fb)
char	*is;
char	*fa;
char	*fb;
{
	nwrslc();
	doshell(is,fa,fb);
	if(kenv.leisur & DA)	{
		scr_so(pfp);
		query(pfp);
		scr_se(pfp);
		scr_cl(pfp);
		}
	return(0);
}
