#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include    <signal.h>
#include    <setjmp.h>
#define		memnull(a,b)memset(a,0,b)
#define     UDIC    "words"
#define     ERR     -1
#define     IAM     "krect"
#define     NLIST   4096
/**/
struct  PATLOC  {
	char    *beg;
	char    *end;
}	;
/**/
typedef	struct  SPELL
{
    char    *err;       /* ERRORS */
    char    *cor;       /* CORRECTIONS */
    char    act;        /* ACTION */
}   SPELL;
/**/
#ifdef	ALLOCATE
#define	GLOBAL	/**/
#else	/*ALLOCATE*/
#define	GLOBAL	extern
#endif	/*ALLOCATE*/
/**/
GLOBAL	KENV	kenv;
/**/
GLOBAL	SPELL	xl;
/**/
GLOBAL	char	*(*reader)();
GLOBAL	long	list[NLIST];	/* list of pointers to errors */
GLOBAL	int		hit;
GLOBAL	char	*cbo;
GLOBAL	char	*cbu;
GLOBAL	int		hits;
GLOBAL	FILE	*wfp;
GLOBAL	char	wfn[FNMSIZ];
GLOBAL	FILE	*efp;
GLOBAL	char	efn[FNMSIZ];
GLOBAL	FILE    *xfp;           /* CONTEXT FILE POINTER */
GLOBAL	char    *xfn;           /* CONTEXT FILE NAME */
GLOBAL	char	*udn;			/* user dictionary name */
GLOBAL	FILE    *pfp;           /* PIPE TO KWED */
GLOBAL	char	*rfn;			/* current file name(s) */
GLOBAL	char    wfn[FNMSIZ];    /* WORK FILE NAME */
GLOBAL	char	*tmpdir;		/* directory for temporary files */
GLOBAL	int		first;			/* first patch switch */
GLOBAL	int     nerrs;          /* NUMBER OF ERRORS */
GLOBAL	int     cen;            /* CURRENT ERROR NUMBER */
GLOBAL	int     words;          /* WRITE TO USER DICTIONARY */
GLOBAL	int     inter;          /* INTERACTIVE MODE */
GLOBAL	char	*speller;        /* SPELL PROGRAM SWITCH */
GLOBAL	char	*amode;
GLOBAL	char	*rmode;
GLOBAL	char	*wmode;
/**/
GLOBAL	jmp_buf jump;
/**/
/*EXTERN*/
#ifdef	CAN_PROTO
extern long writework(SPELL *,int);
extern int readwork(SPELL *,int);
extern char *kpc(char *,char *,char *);
extern int kpx(char *,char *);
extern void kontext(char *,int);
extern int hint(int);
extern int wrudn(char *);
extern int protect(char *);
extern int dikwed(char *);
extern int wrkwed(char *,int);
extern int wrxrc(char *,char *);
extern int wordfold(char *,int);
extern int wordproper(char *,int);
extern int wordunset(char *,int);
extern char *setudn(char *);
extern int tspec(int,char *);
extern char *tfile(void);
extern char *rdcmd(char *);
extern char *rdlst(char *);
extern char *setfiles(char *);
extern int replace(char *,int);
extern void packup(int);
extern int nofile(void);
extern int noerrors(void);
extern int markit(int);
extern int gotoit(void);
extern int permcheck(char *);
extern int execlist(char *);
extern int display(int);
extern int clrxl(void);
extern int errsve(char *, int);
extern int uselist(char *);
extern int geterrs(char *);
extern int failed(char *,char *);
extern int dowords(void);
extern int looker(char *,char *,char *,char *);
extern int dolook(char *,int);
extern int docnt(int);
extern int doerrors(void);
extern int krect(int,char **);
extern int showpat(char *,int,char *,struct PATLOC *);
extern int sweep(char *,char *);
extern int context(char *,int);
extern char *setcbo(int);
extern int setrdr(int);
#else
extern long writework();
extern int readwork();
extern char *kpc();
extern int kpx();
extern void kontext();
extern int hint();
extern int wrudn();
extern int protect();
extern int dikwed();
extern int wrkwed();
extern int wrxrc();
extern int wordfold();
extern int wordproper();
extern int wordunset();
extern char *setudn();
extern int tspec();
extern char *tfile();
extern char *rdcmd();
extern char *rdlst();
extern char *setfiles();
extern int replace();
extern void packup();
extern int nofile();
extern int noerrors();
extern int markit();
extern int gotoit();
extern int permcheck();
extern int execlist();
extern int display();
extern int clrxl();
extern int errsve();
extern int uselist();
extern int geterrs();
extern int failed();
extern int dowords();
extern int looker();
extern int dolook();
extern int docnt();
extern int doerrors();
extern int krect();
extern int showpat();
extern int sweep();
extern int context();
extern char *setcbo();
extern int setrdr();
#endif
