/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/*EXTERN*/
extern	void	abort();
#define     NSTACK  128
static  int     stk[NSTACK];
static  int     *stx = stk;
static  int     *stu = &stk[NSTACK-1];
static  char    *over = "<stack overflow>\n";
static  char    *empty = "<stack empty>\n";
static  char    *illegal = "<illegal stack address>\n";
static  FUNCP   ferr = (FUNCP) 	abort;     /* call this on error */
int	*
istptr()        /* return the NEXT stack location */
{
	return(stx);
}
int	*
istset(xstx)
int *xstx;
{
	extern	int	*istclr();
	if(xstx >= stk && xstx <= stu) return(stx = xstx);
	errmsg(illegal);
	return(istclr());
}
int	*
istclr()        /* clear (initialize) the stack */
{
	return(stx = stk);
}
FUNCP	isterr(fu)
FUNCP	fu;
{
	auto	FUNCP	pu = ferr;
	ferr = fu;
	return(pu);
}
istpush(n)
int n;
{
	if(stx < stu) return(*stx++ = n);
	errmsg(over);
/*  CTEXT
	return((*ferr)) does NOT work. must be done as below
*/
	return((*ferr)());
}
istpop()
{
	if(stx > stk) return(*--stx);
	errmsg(empty);
	return((*ferr)());
}
#ifdef      TEST
fubar()
{
	puts("fubar");
	return(-1);
}
main()
{
	char    line[BUFSIZ];
	while(fputc('?',stderr),gets(line))
	switch(line[0])
	{
	case    'q':    exit(0);
	case    'a':    fprintf(stderr,"%07o\n",isterr(abort));break;
	case    't':    fprintf(stderr,"%07o\n",isterr(fubar));break;
	case    'p':    istpush(atoi(line+1));break;
	case    'f':    fprintf(stderr,"%d\n",istpop());break;
	default:        puts("??");break;
	}
	exit(0);
}
#endif
