/*UNXLIB*/
/*DOSLIB*/
/*
*	if the target does not have links and the source and target
*	are on the same file system or device, try to rename the files.
*
*	different devices cause problems on MSDOS
*	different file systems and symbolic links cause problems for
*	UNIX/XENIX
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/*EXTERN*/
extern	KENV	kenv;
/**/
linkorcopy(src,tar)	/* src -> tar by link or copy */
char	*src;		/* current name */
char	*tar;		/* wanted named */
{
	auto	long	lsrc;
	auto	long	ltar;
	auto	int		ret;
/**/
	diskreset();
/**/
	lsrc = filesize(src);
	ltar = filesize(tar);
/**/
	if(lsrc <= 0L)	{
#ifdef	NO_ZERO
		errmsg("linkor <bad source> '%s'\n",src);
		return(1);
#else	/*NO_ZERO*/
		prwho(" linkor <zero length source> '%s'\n",src);
#endif	/*NO_ZERO*/
		}
/**/
	if(haslinks(tar) >= 2)	{
		ret = fcopy(tar,src);
		if(ret)	return(ret);
		return(unlink(src));
		}
/**/
	if(ltar >= 0L && unlink(tar))	{
		prterr("linkor(unlink) <%s>",tar);
		return(2);
		}
/**/
	ret = rename(src,tar);
#ifdef	VOCAL
	if(ret)	{
		prwho(" linkor <cannot rename> '%s' -> '%s'\n",
			src,tar);
		}
#endif	/*VOCAL*/
/**/
	ltar = filesize(tar);
/**/
	if(ret != ZERO || lsrc != ltar)		{
#ifdef	VOCAL
		prwho(" linkor <copying> %s -> %s\n",src,tar);
#endif	/*VOCAL*/
		ret = fcopy(tar,src);
		}
/**/
	return(ret);
}
#ifndef	MSDOS
rename(src,tar)
char	*src;
char	*tar;
{
	auto	int		ret;
	if(kenv.dosdos)	spurious("rename");
	if(filesize(tar) >= 0L)	{
		if(ret = unlink(tar))	{
			prterr("rename: %s",tar);
			return(ret);
		}
	}
	if(ret = link(src,tar))		{
			prterr("rename: %s",tar);
			return(ret);
		}
	if(ret = unlink(src))		{
			prterr("rename: %s",tar);
			return(ret);
		}
	return(ret);
}
#endif	MSDOS
#ifdef	TEST
terror(){}
KENV	kenv;
	char	ls[FNMSIZ];
	char	os[FNMSIZ];
	char	is[FNMSIZ];
main(argc,argv)
int		argc;
char	*argv[];
{
	disnme(kenv.pname = "linkor");
	kenv.dosdos = isdos();
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
		case	'q':	fclose(stdin);
						break;
		case	'!':	system(ls+1);
						break;
		case	'<':	strcpy(os,strcnd(ls+1));
						break;
		case	'>':	strcpy(is,strcnd(ls+1));
						break;
		case	'l':	linkorcopy(os,is);
						break;
		case	's':	printf("%ld\n",filesize(strcnd(ls+1)));
						break;
		default:		puts("q        quit");
						puts("!cmd");
						puts("<string  set os");
						puts(">string  set is");
						puts("l        linkormove(os,is)");
						puts("s file   filesize(file)");
						break;
		}
	exit(0);
}
#endif	TEST
