#include	"pdtar.h"
#include	"pdproto.h"
/**/
char	*
fixname(rs,os,is)
char	*rs;	/* save raw name */
char	*os;	/* massaged version */
char	*is;	/* name in header */
{
/**/
	strxty(is,'\\','/');	/* redundant for **IX */
	if(!oswitch.absnme)		{
		if(is[1] == ':')	strcpy(is,is+2);
		if(is[0] == '/')	strcpy(is,is+1);
		}
/**/
	if(oswitch.pathskip)	chgpath(is);
/*
	the "raw" name may actually have leading /, drive, etc.
	removed.
*/
	strcpy(rs,is);
/**/
	strdos(os,is);
/**/
#ifdef	DEBUG
	fprintf(stderr,"is(%s)\n",is);
	fprintf(stderr,"os(%s)\n",os);
	fprintf(stderr,"rs(%s)\n",rs);
#endif	/*DEBUG*/
	return(os);
}
char	*
chgpath(is)		/* skip first n elements in path name (if any) */
char	*is;
{
	auto	int		skip = oswitch.pathskip;
	auto	char	*eop;
	while(skip-- >= 1 && (int) (eop = strchr(is,'/')))	{
		strcpy(is,eop+1);
		}
	return(is);
}
#ifdef MSDOS
char 	*
strdos(os,is)			/* make a usable msdos name */
char	*os;
char	*is;
{
#define		DOT		'.'
#define		SLH		'/'
#define		COL		':'
#define		XYZ		'_'
	auto	char	*eop;
	auto	int		ncc;
	auto	char	ws[NAMSIZ];
	auto	char	*wsx;
	auto	char	driv[3];
	auto	char	extn[5];
	auto	char	name[9];
	auto	char	dirt[66];
	auto	char	path[80];
/**/
	wsx = strcpy(ws,is);
/**/
	invalid(wsx);
/**/
	driv[0] = extn[0] = name[0] = dirt[0] = 0;
/**/
	if((int) (eop = strrchr(wsx,COL)))	{
		driv[0] = wsx[0];
		driv[1] = COL;
		driv[2] = 0;
		wsx = eop + 1;
		}
	if((int) (eop = strrchr(wsx,SLH)))	{
		*eop = 0;
		ncc = strlen(wsx);
		ncc = ncc > 64 ? 64 : ncc;
		strncpy(dirt,wsx,ncc);
		dirt[ncc++] = SLH;
		dirt[ncc] = 0;
		wsx = eop + 1;
		}
	if((int) (eop = strrchr(wsx,DOT)))	{
		ncc = strlen(eop);
		ncc = ncc > 4 ? 4 : ncc;
		strncpy(extn,eop,ncc);
		extn[ncc] = 0;
		*eop = 0;	/* restore below */
		}
	strncpy(name,wsx,8);
	name[8] = 0;
	if(strlen(name) == 0)	{
		if(eop)	strncpy(name,eop+1,8);
		else	strcpy(name,"unhidden");
		name[8] = 0;
		}
	if(eop)	*eop = DOT;
	strcpy(path,dirt);
	strcat(path,name);
#ifdef	UNDER
	if(path[0] == '.' && path[1] == '.')	strxty(path+3,'.',XYZ);
	else
	if(path[0] == '.' && path[1] == '/') 	strxty(path+2,'.',XYZ);
	else									strxty(path,'.',XYZ);
#endif	/*UNDER*/
	strcat(path,extn);
	return(strcpy(os,path));
}
char	*
invalid(is)		/* convert invalid characters */
char	*is;
{
	register	char	*isx = is;
	while(*isx != 0) switch(*isx) {
		case	'"':
		case	'[':
		case	']':
		case	':':
		case	';':
		case	'|':
		case	'<':
		case	'>':
		case	'+':
		case	'=':
		case	',':	*isx++ = 'z';
						break;
		default:		isx++;
						break;
	}
	return(is);
}
#else	/* MSDOS */
char	*
strdos(os,is)		/* simple copy for **IX */
char	*os;
char	*is;
{
	strcpy(os,is);
	if(oswitch.capital)	{
		auto	char	*eop = strrchr(os,'/');
		if(eop)	{
			*eop = '0';
			strupr(os);
			*eop = '/';
			}
		}
	return(os);
}
#endif	/* MSDOS */
