/*DOSLIB*/
/*UNXLIB*/
#define     DEBUG
#undef      DEBUG
#define     EXPAND
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include    <signal.h>
/**/
/*DEFINE*/
#define     WORKFILE    "/xtXXXXXX.tmp"
#define     pwc(a)(((a>=' '&&a<='~'))?1:((a == '\b')?-1:0))
/*EXTERNAL*/
extern		int		xtabs();
extern      int     rebuild();
extern      int     tabfixr();
extern      char    *entabs();
extern      char    *expand();
/*GLOBAL*/
KENV    kenv;
char    *tmpdir;
FILE    *ofp = stdout;
int     lc =    '_';        /* leader character */
int     ta =    4;          /* tab interval */
int     tc =    '\t';       /* tab character */
int     en =    0;          /* entab switch */
int     al =    0;          /* all (1) or leading only (0) */
int     ut =    1;          /* utime reset */
int     rb =    1;          /* rebuild or not */
/*
*/
/* ### Warning xtabs.c 34: Function should return a value in function dummy === */
dummy(){}
/*
*/
void
terror(n)
{
/* ### Warning xtabs.c 40: Call to function 'errmsg' with no prototype in function terror === */
    errmsg("<killed by signal> %d\n",n);
    exit(n);
}
/*
*/
main(argc,argv)
int     argc;
char    *argv[];
{
    kenv.dosdos = isdos();
    disnme(kenv.pname = "xtabs");
	exit(cmdxrc(argc,argv,xtabs,"xtabs.xrc"));
/* ### Warning xtabs.c 52: Function should return a value in function main === */
}
xtabs(argc,argv)
int     argc;
char    *argv[];
{
/**/
    if(kenv.dosdos) cmdxpd(argc,argv);
    else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
/* ### Warning xtabs.c 63: Call to function 'hint' with no prototype in function xtabs === */
    if(cmdnum(argc,argv,'h',0,1))   hint(0);
/**/
    if(signal(SIGINT,SIG_IGN) != SIG_IGN)
        signal(SIGINT,terror);
/* ### Warning xtabs.c 67: Call to function 'setsig' with no prototype in function xtabs === */
	setsig((FUNCP) terror);
/**/
    al = cmdnum(argc,argv,'a',0,1);
    en = cmdnum(argc,argv,'e',0,1);
    ta = cmdnum(argc,argv,'t',4,4);
    tc = cmdchr(argc,argv,'c','\t','\t');
    lc = cmdchr(argc,argv,'l',' ','_');
    ut = cmdnum(argc,argv,'u',1,1);
    rb = cmdnum(argc,argv,'r',DA,DA);
    kenv.prompt = cmdnum(argc,argv,'v',DA,DA);
    if(rb)  dolist(argc,argv,rebuild);
    else    dolist(argc,argv,tabfixr);
    exit(0);
/* ### Warning xtabs.c 80: Function should return a value in function xtabs === */
}
rebuild(fp)
FILE    *fp;
{
    auto    char        ws[FNMSIZ];
    auto    unsigned    mode;
    auto    long        begsiz;
    auto    long        endsiz;
    auto    double      differ;
/**/
    begsiz = filesize(getcfn());
/**/
    tmpdir = (int) (tmpdir = kgetenv("TMPDIR")) ? tmpdir : "." ;
    strcpy(ws,tmpdir);
    strcat(ws,WORKFILE);
    maketemp(ws);
/**/
    ofp = tefopen(ws,kenv.dosdos ? "wb" : "w");
/**/
/* ### Warning xtabs.c 99: Call to function 'tabfixr' with no prototype in function rebuild === */
    tabfixr(fp);
/**/
    ofp = xfclose(ofp);
/**/
    if(ut)  {
        mode = fileperm(getcfn());
        gut(getcfn());
        }
/**/
    if(linkorcopy(ws,getcfn())) terror(FUBAR);
/**/
    if(ut)  {
        sut(getcfn());
/* ### Warning xtabs.c 112: Call to function 'chmod' with no prototype in function rebuild === */
        chmod(getcfn(),mode);
        }
/**/
    endsiz = filesize(getcfn());
/**/
    if(kenv.prompt) {
        differ = ((double) begsiz - (double) endsiz) / (double) begsiz;
        differ *= 100.0;
        printf("%s %5.1f%% change\n",getcfn(),differ);
        }
/**/
    return(ZERO);
}
tabfixr(fp)
FILE    *fp;
{
    auto    char    ls[BUFSIZ];
    auto    char    os[BUFSIZ];
    auto    int     ln = 0;
    auto    int     len = en;       /* local entab switch */
#ifdef  DEBUG
    printf("tabfixr(%u)\n",fp);
#endif  DEBUG
    while(fgetls(ls,ls+BUFSIZ-1,fp))    {
        ln += 1;
#ifdef  DEBUG
    printf("tabfixr(%s)\n",ls);
#endif  DEBUG
/*
**  expand to catch any unexpected tabs
*/
/* ### Warning xtabs.c 143: Call to function 'expand' with no prototype in function tabfixr === */
        expand(os,os+BUFSIZ-1,ls);
        if(os[0] == '/' &&
            strncmp(os,"/*NO_TABS*/",11) == 0)  len = 0;
        else
        if(os[0] == '/' &&
            strncmp(os,"/*TABS*/",8) == 0)      len = 1;
        if(en && len)  {
            strcpy(ls,os);
/* ### Warning xtabs.c 151: Call to function 'entabs' with no prototype in function tabfixr === */
            entabs(os,os+BUFSIZ-1,ls);
            }
        fputs(os,ofp);
        if(kenv.dosdos) fputs("\r\n",ofp);
            else    fputs("\n",ofp);
    }
    return(ln);
}
char    *
entabs(os,us,is)
char    *os, *us, *is;
{
    auto        char    *osx = os;
    auto        char    *isx = is;
    auto        char    *usx = us;
    auto        int     cp = 1;
    auto        int     xp = cp;
    auto        int     lb = 0;
    while(*isx != ZERO)
    if(*isx == lc)  {
            if(lb >= 1 && al == 0)  {
                *osx++ = *isx++;
                xp = cp += 1;
                continue;
                }
            xp = cp;
            while(*isx == ' ')  {
                xp += 1;
                isx += 1;
                if(xp % ta == 1)    {
                    *osx++ = tc;
                    cp = xp;
                    }
            }
            while(cp < xp)  {
                *osx++ = lc;
                cp += 1;
                }
        }
    else    {
        lb = 1;
        cp += pwc(*isx);
        *osx++ = *isx++;
        }
    *osx++ = ZERO;
    if(osx > usx)   {
        fprintf(stderr,"\007(%s) entabs <overflow>\n",kenv.pname);
        terror(FUBAR);
        return(NULL);
        }
    return(os);
}
char    *
expand(os,us,is)
char    *os, *us, *is;
{
    auto        char    *osx = os;
    auto        char    *isx = is;
    auto        char    *usx = us;
    auto        int     cp = 1;
    while(*isx != ZERO) {
    if(*isx == tc)  {
            isx += 1;
            do  {
                *osx++ = lc;
                cp += 1;
            }   while(cp % ta != 1) ;
        }
    else    {
        cp += pwc(*isx);
        *osx++ = *isx++;
        }
    }
    *osx++ = ZERO;
    if(osx > usx)   {
        fprintf(stderr,"\007(%s) expand: <overflow>\n",kenv.pname);
        terror(FUBAR);
        return(NULL);
        }
    return(os);
}
hint(ty)
{
static  char    *hx[] = {
"=xtabs [-options] [files]",
"*       expand or compress tabs and blanks in text or program",
"*       files.  the expansion factor and tab character may be",
"*       set by the user.",
"=OPTIONS",
"-a      all blanks to tabs [leading only]        ",
"-e      blanks to tabs [tabs to blanks]",
"-h      hint function",
"-tN     tab interval [4]",
"-t c    tab character [\\t]",
"-l c    leader character [ ]",
"-r0     do not rewrite files",
"-u      restore times, permissions [1]",
"=",
"~",
"=USE WITH C PROGRAMS",
"*       conversion of blanks to tabs may be controlled with the",
"*       following two pseudo-comments.",
"*",
"*       /*NO_TABS*/",
"*       /*TABS*/",
"=MSDOS",
"*      identical to the UNIX version.  output lines follow the",
"*      conventions of the host system.",
"=",
}   ;
    prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
    exit(ty);
/* ### Warning xtabs.c 263: Function should return a value in function hint === */
}

